/*
 * 滴滴答题 http 接口(上传)，node.js 示例代码 
 * 注意：需要安装restler 和 rd: npm install restler rd
 */
var rest = require('restler'),
    fs = require('fs');
var path = require('path');
var rd = require('rd');
var config = {
    host: 'api.dididati.com',
    port: 80,
}

var folder = './images/';
var arg = process.argv.splice(2);
if (arg.length) {
    config = require('./' + arg[0]);
    folder = arg[1] ? arg[1] : folder;
}
var userkey = "";
var appkey = "673ff68944ede5879d46d4187888723a8e2edb1e503a3baf";
var ua = "dididatiNode/1.0";

function decode(filename) {
    rest.post('http://' + config.host + ':' + config.port + '/upload', {
        multipart: true,
        data: {
            'userkey': userkey,
            'appkey': appkey,
            'image': rest.file(filename, null, fs.statSync(filename).size, null, 'image/jpeg') // filename: 抓取回来的码证码文件
        },
        headers: {
            'User-Agent': ua,
            'Content-Type': 'application/x-www-form-urlencoded'
        },
    }).on('success', function(data) {
        // var captcha = JSON.parse(data);
        var f = path.basename(filename).toLowerCase();
        var real = f.substr(0, f.indexOf('.'));
        var correct = (real === data)
        console.log(path.basename(filename), real, data, correct);
        //console.log(filename, data)
    });
}

function login(username, password, cb) {
    rest.get('http://' + config.host + ':' + config.port + '/login', {
        query: {
            'username': username,
            'password': password
        },
        headers: {
            'User-Agent': ua,
            'Content-Type': 'application/x-www-form-urlencoded'
        }
    }).on('success', function(data) {
        userkey = data;
        console.log('login', data);
        cb();
    }).on('error', function(err) {
        console.log(err);
    });
}

function reporterror() {
    rest.get('http://' + config.host + ':' + config.port + '/report', {
        query: {
            'userkey': userkey,
            'appkey': appkey,
        },
        headers: {
            'User-Agent': ua,
            'Content-Type': 'application/x-www-form-urlencoded'
        }
    }).on('success', function(data) {
        console.log('report', data);
    }).on('error', function(err) {
        console.log(err);
    });
}

login('test', '******', function(err) {
    //reporterror();
    var files = rd.readSync(folder);
    for (var i = 0; i < files.length; i++) {
        if (/.(jpeg|jpg|png|gif)$/i.exec(files[i])) {
            decode(files[i]);
        }
    };
});